// SPDX-FileCopyrightText: 2024 Yury Gubich <blue@macaw.me>
// SPDX-License-Identifier: GPL-3.0-or-later

#include "message.h"

#include <iostream>

Message::Message(const std::shared_ptr<Config>& config, const std::shared_ptr<gloox::Client>& client, const Callback& callback):
    callback(callback),
    config(config),
    client(client)
{
    client->registerMessageHandler(this);
}

Message::~Message() {
    if (std::shared_ptr<gloox::Client> cl = client.lock())
        cl->removeMessageHandler(this);
}

void Message::handleMessage(const gloox::Message& message, gloox::MessageSession* session) {
    callback(message.from().bare(), message.body());
}
