// SPDX-FileCopyrightText: 2024 Yury Gubich <blue@macaw.me>
// SPDX-License-Identifier: GPL-3.0-or-later

#pragma once

#include <string>
#include <memory>
#include <vector>

#include "gloox/client.h"

#include "component/actor.h"

namespace Module {

class Module {
public:
    typedef std::vector<std::string> Tokens;

protected:
    Module(const std::shared_ptr<gloox::Client>& client);
    void sendMessage(const std::shared_ptr<Actor>& actor, const std::string& body);

public:
    virtual ~Module() noexcept;

    static Tokens split(const std::string& string, const std::string& delimiter = " ");

    virtual void message(const std::shared_ptr<Actor>& actor, const Tokens& args) = 0;

protected:
    std::shared_ptr<gloox::Client> client;

};

}
